import os
import numpy as np

ariskBaseDir = os.path.dirname(os.path.abspath(__file__))
ReportBarVerde = "\"progress-bars1 cid-rCU8qeDahk\""
ReportBarRosso = "\"progress-bars1 cid-rCU9dON4cu\""
ReportBarGiallo = "\"progress-bars1 cid-rCU900AcwK\""

ReportFacciaRossa = "style=\"color: rgb(255, 51, 102); fill: rgb(255, 51, 102);\""
ReportFacciaGialla = "style=\"color: rgb(247, 237, 74); fill: rgb(247, 237, 74);\""

OverallYellow = 0.4
OverallRed = 0.6

YearlyYellow = 0.5
YearlyRed = 0.7

cols = ['ATT10', 'ATT11', 'ATT12', 'ATT13', 'ATT14', 'ATT15', 'ATT16', 'ATT17', 'ATT18', 'ATT19',
        'ATT20', 'ATT21', 'ATT22', 'ATT23', 'ATT24']
gov_cols = ['ATT10', 'ATT12', 'GOV10', 'GOV15',	'GOV04', 'GOV09', 'GOV08']
indices = [
    'Ricavi delle vendite',
    'EBITDA/Vendite (%)',
    'EBITDA migl EUR',
    'Indice di liquidità',
    'Indice corrente',
    'Indice di indebitam. a lungo',
    'Indice di copertura delle immob. (patrimoniale)',
    'Grado di ammortamento',
    'Debiti v/banche su fatt. (%)',
    'Grado di copertura degli interessi passivi',
    'Giac. media delle scorte (gg)',
    'Giorni copertura scorte (gg)',
    'Redditività di tutto il capitale investito (ROI) (%)',
    'Flusso di cassa di gestione',
    'Oneri finanz. su fatt. (%)'
]

indicesText = [
    'Ricavi delle vendite',
    'EBITDA/Vendite (%)',
    'EBITDA migl EUR',
    'Indice di liquidità',
    'Indice corrente',
    'Indice di indebitam. a lungo',
    'Indice di copertura delle immob. (patrimoniale)',
    'Grado di ammortamento',
    'Debiti v/banche su fatt. (%)',
    'Grado di copertura degli interessi passivi',
    'Giac. media delle scorte (gg)',
    'Giorni copertura scorte (gg)',
    'Redditività di tutto il capitale investito (ROI) (%)',
    'Flusso di cassa di gestione',
    'Oneri finanz. su fatt. (%)'
]

fileTrain1Y = './miglior-taratura/rf_clf_1y.pkl'
fileTrain2Y = './miglior-taratura/rf_clf_2y.pkl'
fileTrain3Y = './miglior-taratura/rf_clf_3y.pkl'
fileTrain4Y = './miglior-taratura/rf_clf_4y.pkl'
fileTrain5Y = './miglior-taratura/rf_clf_5y.pkl'
fileTrainGov = './miglior-taratura/GOVERNANCE_REGRESSOR_GP.pkl'


BaseDir = os.path.dirname(os.path.abspath(__file__))
ariskStaticFiles = BaseDir+'/static/'

debug = False

ReportSfondoRosso = "myerror"
ReportSfondoGiallo = "mywarning"
ReportSfondoVerde = "mysuccess"

probabilities = {'Bassa': 1, 'Media': 2, 'Alta': 3}
impact_rate = {"Impatto trascurabile su processi e/o prodotti/servizi": 1,
               "Impatto medio su processi e/o prodotti/servizi": 2,
               "Impatto alta su processi e/o prodotti/servizi": 3}

gravity = {"Nessuna": 1, "Minima": 2, "Media": 3, "Alta": 4, "Altissima": 5}

implication = {"Amministrative": "non_penali", "Penali": "penali",
               "Amministrative e penali": "mid_penali", "Nessuna": "non_penali"}

alpha = [0, 0, 0, 0, 0, 0, 0, 0]
alpha2 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]

beta = [[1, 0, 0, 0, 0, 0, 0, 0],
        [0, 1, 0, 0, 0, 0, 0, 0],
        [0, 0, 1, 1, 0, 0, 0, 0],
        [0, 0, 0, 0, 1, 0, 0, 0],
        [0, 0, 0, 0, 1, 0, 0, 0],
        [0, 0, 0, 0, 1, 0, 0, 0],
        [0, 0, 0, 0, 0, 1, 1, 1],
        [0, 1, 0, 0, 0, 0, 0, 0]]

beta2 = [[0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0],
         [1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0],
         [0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
         [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0],
         [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0],
         [0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0],
         [0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 1],
         [1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0]]

beta3 = [[1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
         [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
         [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
         [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
         [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
         [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
         [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
         [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]]

gamma1 = [-0.1, -0.1, -0.1, -0.1, -0.1, 0.1, -0.1, 0.1, 0.1, 0.1, 0.1, 0.1, -0.1, -0.1, 0.1]
gamma2 = [-0.2, -0.2, -0.2, -0.2, -0.2, 0.2, -0.2, 0.2, 0.2, 0.2, 0.2, 0.2, -0.2, -0.2, 0.2]
gamma3 = [-0.3, -0.3, -0.3, -0.3, -0.3, 0.3, -0.3, 0.3, 0.3, 0.3, 0.3, 0.3, -0.3, -0.3, 0.3]
gamma4 = [-0.4, -0.4, -0.4, -0.4, -0.4, 0.4, -0.4, 0.4, 0.4, 0.4, 0.4, 0.4, -0.4, -0.4, 0.4]
gamma5 = [-0.5, -0.5, -0.5, -0.5, -0.5, 0.5, -0.5, 0.5, 0.5, 0.5, 0.5, 0.5, -0.5, -0.5, 0.5]
gamma8 = np.multiply(gamma1, 60)

mydeltaChange = [
    -1,  # 'Ricavi delle vendite',
    -1,  # 'EBITDA/Vendite (%)',
    -1,  # 'EBITDA migl EUR',
    -1,  # 'Indice di liquidità',
    -1,  # 'Indice corrente',
    1,   # 'Indice di indebitam. a lungo',
    -1,  # 'Indice di copertura delle immob. (patrimoniale)',
    1,   # 'Grado di ammortamento',
    1,   # 'Totale Debiti su fatt. (%)',
    1,   # 'Grado di copertura degli interessi passivi',
    1,   # 'Giac. media delle scorte (gg)',
    1,   # 'Giorni copertura scorte (gg)',
    -1,  # 'Redditività di tutto il capitale investito (ROI) (%)',
    -1,  # 'Flusso di cassa di gestione',
    1    # 'Oneri finanz. su fatt. (%)'
]

AI4BCYellow = OverallYellow
AI4BCRed = OverallRed

AI4RiskYellow = OverallYellow
AI4RiskRed = OverallRed

gov_indexes = [
    'Ricavi',
    'EBITDA',
    'DM ETA',
    'Shareholder also manager',
    'Azionisti % Diretta',
    'DM Carica.1',
    'Numero di esponenti & manager attuali'
]

gov_indices = [
    'GOV01', 'GOV04', 'GOV06', 'GOV07', 'GOV08', 'GOV12',
    'GOV13', 'GOV15', 'GOV16', 'GOV16_3', 'GOV22', 'GOV23',
    'GOV24', 'GOV27', 'GOV28', 'ATT12']

mediaPesataAnni = [0.45, 0.32, 0.23]
mediaPesataAnniBC = mediaPesataAnni

percentili = [0.9,
              0.855251142,
              0.823287671,
              0.8,
              0.763926941,
              0.731050228,
              0.68630137,
              0.631050228,
              0.522374429,
              0.4
              ]

myDelta = [0.2, 0.5, 0.7]
myGovChange = [-1, -1, -1, -1, -1, -1, 1, -1, 1, 1, 1, 1, -1, -1, 1]

ai4BCErrors = ['Dati sulla compagine sociale inconsistenti',
               'Nulla da segnalare',
               'Numero di soci per la maggioranza minore di 2',
               'Numero di soci per la maggioranza minore di 4'
               ]

surveyRatio = 1.0
surveyNumbersFloats = True

finMLColumns = [  
        'Revenues', #'Ricavi delle vendite',
        'EBITDA Margin', #'Ricavi delle vendite',
        'EBITDA', #'EBITDA migl EUR'
        'Quick ratio', #'Indice di liquidità',
        'Current ratio', #'Indice corrente',
        'Long-Term Liability Ratio', #'Indice di indebitam. a lungo',
        'Coverage Of Fixed Assets', #'Indice di copertura delle immob. (patrimoniale)',
        'Amortisation Rate', #'Grado di ammortamento',
        'Debt On Sales', #'Debiti su fatt. (%)',
        'Interest Coverage Ratio', #'Grado di copertura degli interessi passivi',
        'Average Stock Turnover', #'Giac. media delle scorte (gg)',
        'Stock Coverage Days', #'Giorni copertura scorte (gg)',
        'Return On Investments  (ROI)', #'Redditività di tutto il capitale investito (ROI) (%)',
        'Cash Flow', #'Flusso di cassa di gestione',
        'Interest On Sales', #'Oneri finanz. su fatt. (%)'
        'Net Working Capital', #Capitale Circolante Netto
        'Net Financial Position', #Posizione Finanziaria netta
        'Net Short-Term Assets', #Margine di Tesoreria
        'Shareholder Funds-Fixed Assets', #Margine di Struttura
        'Return on Asset (ROA)', #ROA
        'Return on Sales (ROS)', #ROS
        'Return on Equity (ROE)', #ROE
        'Type of Financial Statement' #NEW MPAI a scelta tra Abbreviated, Micro, Detailed
                ]

finMLColumnsAIDA = [  
        'Revenues', #'Ricavi delle vendite',
        'EBITDA Margin', #'Ricavi delle vendite',
        'EBITDA', #'EBITDA migl EUR'
        'Quick ratio', #'Indice di liquidità',
        'Current ratio', #'Indice corrente',
        'Long-Term Liability Ratio', #'Indice di indebitam. a lungo',
        'Coverage Of Fixed Assets', #'Indice di copertura delle immob. (patrimoniale)',
        'Amortisation Rate', #'Grado di ammortamento',
        'Debt On Sales', #'Debiti su fatt. (%)',
        'Interest Coverage Ratio', #'Grado di copertura degli interessi passivi',
        'Average Stock Turnover', #'Giac. media delle scorte (gg)',
        'Stock Coverage Days', #'Giorni copertura scorte (gg)',
        'Return On Investments  (ROI)', #'Redditività di tutto il capitale investito (ROI) (%)',
        'Cash Flow', #'Flusso di cassa di gestione',
        'Interest On Sales', #'Oneri finanz. su fatt. (%)'
        'Net Working Capital', #Capitale Circolante Netto
        'Net Financial Position', #Posizione Finanziaria netta
        'Net Short-Term Assets', #Margine di Tesoreria
        'Shareholder Funds-Fixed Assets', #Margine di Struttura
        'Return on Asset (ROA)', #ROA
        'Return on Sales (ROS)', #ROS
        'Return on Equity (ROE)', #ROE
        'Type of Financial Statement' #NEW MPAI a scelta tra Abbreviated, Micro, Detailed
                    ]

finGOVColumns = ['DM_eta',
                 'Shareholder - Also a manager',
                 'Azionisti Diretta',
                 'DM Carica.1',
                 'Numero di esponenti & manager attuali']

DSCPTassoMedio = 0.02
DSCPTassoMedioCapitale = 0.20

NullValue = 100000000

x_data_cols = [
        'ATT10',
        'ATT11',
        'ATT12',
        'ATT13',
        'ATT14',
        'ATT15',
        'ATT16',
        'ATT17',
        'ATT18',
        'ATT19',
        'ATT20',
        'ATT21',
        'ATT22',
        'ATT23',
        'ATT24'
]

anagraficaCols_redflag = [
    'ATT1',
    'ATT3',
    'ATT6'
]

anagraficaCols_RFRBAI = [
    'ATT1',
    'ATT3',
    'ATT6',
    'EQFStart',
    'EQFEnd',
    'AQStart',
    'AQEnd'
    ]
