import ariskparametri
import re
import random
import copy


def myprint(mystring):
	if ariskparametri.debug:
		print(mystring)


def f2swithsep(s, thou=",", dec="."):
	integer, decimal = s.str.split(".")
	integer = re.sub(r"\B(?=(?:\d{3})+$)", thou, integer)
	return integer + dec + decimal


def is_number(n):
	try:
		float(n)
	except ValueError:
		return False
	return True


def s2fwithsep(mystring, check=1):
	if check:
		if not mystring:
			return ariskparametri.NullValue
	else:
		if not mystring:
			return 0

	if mystring == 'n.a.':
		return ariskparametri.NullValue
	partition = mystring.partition('.')
	if (is_number(partition[0]) and partition[1] == '.' and partition[2].isdigit()) \
		or (partition[0] == '' and partition[1] == '.' and partition[2].isdigit()) \
		or (is_number(partition[0]) and partition[1] == '.' and partition[2] == ''):
		mystring = mystring.replace(".", "")
		mystring = mystring.replace(",", ".")
		value = float(mystring)
	else:
		mystring = mystring.replace(".", "")
		mystring = mystring.replace(",", ".")
		value = float(mystring)

	return value


def perturbAQ(AQSurvey, perc=0.1):
	tmpValue=float()
	newSurvey = copy.deepcopy(AQSurvey)

	for i in range(5):
		tmpValue = s2fwithsep(newSurvey[7]['fixedRows'][i]['values'][0]['value'])
		tmpValue = tmpValue*(1+random.random()*perc)
		newSurvey[7]['fixedRows'][i]['values'][0]['value'] = str(tmpValue)

	for i in range(27):
		tmpValue = s2fwithsep(newSurvey[13]['fixedRows'][i]['values'][0]['value'])
		tmpValue = tmpValue*(1+random.random()*perc)
		newSurvey[13]['fixedRows'][i]['values'][0]['value'] = str(tmpValue)

	tmpValue = s2fwithsep(newSurvey[14]['fixedRows'][0]['values'][0]['value'])
	tmpValue = tmpValue*(1+random.random()*perc)
	newSurvey[14]['fixedRows'][0]['values'][0]['value'] = str(tmpValue)
	for i in range(5):
		tmpValue = s2fwithsep(newSurvey[16]['fixedRows'][i]['values'][0]['value'])
		tmpValue = tmpValue*(1+random.random()*perc)
		newSurvey[16]['fixedRows'][i]['values'][0]['value'] = str(tmpValue)

	for i in range(5):
		tmpValue = s2fwithsep(newSurvey[17]['fixedRows'][i]['values'][0]['value'])
		tmpValue = tmpValue * (1 + random.random() * perc)
		newSurvey[17]['fixedRows'][i]['values'][0]['value'] = str(tmpValue)

	return newSurvey


def stringFromJson(data):
	if data:
		return data
	else:
		return ''


def try_div(x, y):
	try:
		return x/y
	except ZeroDivisionError:
		return ariskparametri.NullValue
